
In order to perform data/file analysis and manipulation you must known how commands work the usefull commands for these tasks.

{%
    include-markdown "../bash/bash-7-commands.md"
%}

## Useful commands

For efficiently analyzing and manipulating data and files directly from the command line, there is a bunch of essential commands:

| Command | Explanation |
|---------|-------------|
| **`grep`**  | Search for patterns within files |
| **`awk`**   | A powerful programming language for pattern scanning and processing |
| **`sed`**   | Stream editor for filtering and transforming text |
| `cut`   | Remove sections from each line of files |
| `sort`  | Sort lines of text files |
| `uniq`  | Report or omit repeated lines |
| `head`  | Display the beginning of a file |
| `tail`  | Display the end of a file |
| `tr`    | Translate or delete characters |
| `wc`    | Print newline, word, and byte counts for each file |
| `find`  | Search for files in a directory hierarchy |
| `diff`  | Compare files line by line |
| `comm`  | Compare two sorted files line by line |
| `tee`   | Read from standard input and write to standard output and files |
